<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.16"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>Zonzay: fine_hog_image_abstract.h Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectlogo"><img alt="Logo" src="zonzay.png"/></td>
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">Zonzay
   &#160;<span id="projectnumber">1</span>
   </div>
   <div id="projectbrief">Laugh game challenge</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.16 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_f6486992fdfcc735347cc2d407578037.html">FaceFilterSDK</a></li><li class="navelem"><a class="el" href="dir_80a4fd4d67846ee877317f9ddd7282cb.html">DlibWrapper</a></li><li class="navelem"><a class="el" href="dir_9b7b8713e4f43f3006d0cb3c779d469e.html">dlib</a></li><li class="navelem"><a class="el" href="dir_08f7efc97bc6b4dfa46916aa4398cde3.html">image_keypoint</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="headertitle">
<div class="title">fine_hog_image_abstract.h</div>  </div>
</div><!--header-->
<div class="contents">
<div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">// Copyright (C) 2012  Davis E. King (davis@dlib.net)</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment">// License: Boost Software License   See LICENSE.txt for the full license.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="preprocessor">#undef DLIB_FINE_HOG_IMaGE_ABSTRACT_Hh_</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="preprocessor">#ifdef DLIB_FINE_HOG_IMaGE_ABSTRACT_Hh_</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160; </div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="preprocessor">#include &quot;../array2d.h&quot;</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="preprocessor">#include &quot;../matrix.h&quot;</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="preprocessor">#include &quot;hog_abstract.h&quot;</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160; </div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160; </div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="keyword">namespace </span><a class="code" href="namespacedlib.html">dlib</a></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;{</div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> cell_size_,</div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> block_size_,</div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> pixel_stride_,</div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> num_orientation_bins_,</div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;        <span class="keywordtype">int</span>           gradient_type_</div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;        &gt;</div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;    <span class="keyword">class </span>fine_hog_image : noncopyable</div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;    {</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    <span class="keyword">public</span>:</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160; </div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> cell_size = cell_size_;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> block_size = block_size_;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> pixel_stride = pixel_stride_;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> num_orientation_bins = num_orientation_bins_;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">int</span>           gradient_type = gradient_type_;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160; </div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;        <span class="keyword">const</span> <span class="keyword">static</span> <span class="keywordtype">long</span> min_size = cell_size*block_size+2;</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160; </div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;        <span class="keyword">typedef</span> matrix&lt;double, block_size*block_size*num_orientation_bins, 1&gt; descriptor_type;</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160; </div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;        fine_hog_image (</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;        );</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;        <span class="keywordtype">void</span> clear (</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;        );</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;        <span class="keywordtype">void</span> copy_configuration (</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;            <span class="keyword">const</span> fine_hog_image&amp;</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;        );</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;        <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;            <span class="keyword">typename</span> image_type</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;            &gt;</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">void</span> load (</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;            <span class="keyword">const</span> image_type&amp; img</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;        );</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">void</span> unload(</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;        );</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> size (</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">long</span> nr (</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;        <span class="keyword">inline</span> <span class="keywordtype">long</span> nc (</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;        <span class="keywordtype">long</span> get_num_dimensions (</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;        <span class="keyword">inline</span> <span class="keyword">const</span> descriptor_type&amp; operator() (</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;            <span class="keywordtype">long</span> row,</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;            <span class="keywordtype">long</span> col</div><div class="line"><a name="l00168"></a><span class="lineno">  168</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;        <span class="keyword">const</span> rectangle get_block_rect (</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;            <span class="keywordtype">long</span> row,</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;            <span class="keywordtype">long</span> col</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;        <span class="keyword">const</span> point image_to_feat_space (</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;            <span class="keyword">const</span> point&amp; p</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;        <span class="keyword">const</span> rectangle image_to_feat_space (</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;            <span class="keyword">const</span> rectangle&amp; rect</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;        <span class="keyword">const</span> point feat_to_image_space (</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;            <span class="keyword">const</span> point&amp; p</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;        <span class="keyword">const</span> rectangle feat_to_image_space (</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;            <span class="keyword">const</span> rectangle&amp; rect</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;        ) <span class="keyword">const</span>;</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    };</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160; </div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160; </div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> T1,</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> T2,</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> T3,</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> T4,</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;        <span class="keywordtype">int</span>           T5</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;        &gt;</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <span class="keywordtype">void</span> serialize (</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;        <span class="keyword">const</span> fine_hog_image&lt;T1,T2,T3,T4,T5&gt;&amp; item,</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;        std::ostream&amp; out</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    );</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;    <span class="keyword">template</span> &lt;</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> T1,</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> T2,</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">long</span> T3,</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;        <span class="keywordtype">unsigned</span> <span class="keywordtype">char</span> T4,</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;        <span class="keywordtype">int</span>           T5</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;        &gt;</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    <span class="keywordtype">void</span> deserialize (</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;        fine_hog_image&lt;T1,T2,T3,T4,T5&gt;&amp; item,</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;        std::istream&amp; in </div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    );</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;<span class="comment">// ----------------------------------------------------------------------------------------</span></div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160; </div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;}</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160; </div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;<span class="preprocessor">#endif // DLIB_FINE_HOG_IMaGE_ABSTRACT_Hh_</span></div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160; </div></div><!-- fragment --></div><!-- contents -->
<div class="ttc" id="anamespacedlib_html"><div class="ttname"><a href="namespacedlib.html">dlib</a></div><div class="ttdef"><b>Definition:</b> algs.h:119</div></div>
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.16
</small></address>
</body>
</html>
